<template>
  <el-dialog
    :title="title"
    :visible.sync="dialogFormVisible"
    width="500px"
    @close="close"
  >
    <el-form ref="form" label-width="80px" :model="form" :rules="rules">
      <el-form-item :label="__('类型名称')" prop="feedback_type_name">
        <el-input
          v-model="form.feedback_type_name"
          :placeholder="__('类型名称')"
        />
      </el-form-item>
      <el-form-item prop="feedback_type_enable">
        <el-switch
          v-model="form.feedback_type_enable"

          active-text="开启"
          :active-value="1"

          inactive-text="关闭"
          :inactive-value="0"
        />
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="close">{{ __('取消') }}</el-button>
      <el-button type="primary" @click="save">{{ __('确定') }}</el-button>
    </div>
  </el-dialog>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'

  import { doEdit } from '@/api/plantform/feedback/type'

  export default {
    name: 'PlantformFeedbackTypeEdit',
    data() {
      return {
        form: {
          feedback_type_enable: 1,
        },
        rules: {},
        title: '',
        dialogFormVisible: false,
      }
    },
    created() {},
    mounted() {
      this.form = {
        unit_name: '',
      }

      this.rules = {
        feedback_type_id: [
          { required: true, trigger: 'blur', message: this.__('反馈类型编号') },
        ],
        feedback_type_name: [
          { required: true, trigger: 'blur', message: this.__('类型名称') },
        ],
        feedback_type_enable: [
          { required: true, trigger: 'blur', message: this.__('是否启用') },
        ],
        feedback_type_genus: [
          { required: true, trigger: 'blur', message: this.__('所属身份') },
        ],
      }

      this.$forceUpdate()
    },
    methods: {
      __,
      showEdit(row) {
        if (!row) {
          this.title = this.__('添加')
        } else {
          this.title = this.__('编辑')
          this.form = Object.assign({}, row)
        }
        this.dialogFormVisible = true
      },
      close() {
        this.form = this.$options.data().form
        this.$refs['form'].resetFields()
        this.dialogFormVisible = false
      },
      save() {
        this.$refs['form'].validate(async (valid) => {
          if (valid) {
            const { msg, status } = await doEdit(this.form)
            if (200 == status) {
              this.$baseMessage(msg, 'success')
            } else {
              this.$baseMessage(msg, 'error')
            }
            this.$emit('fetch-data')
            this.close()
          } else {
            return false
          }
        })
      },
    },
  }
</script>
